## highway 1.0.7

=== CMakeLists.txt ===
# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.10)

# Set PIE flags for POSITION_INDEPENDENT_CODE targets, added in 3.14.
if(POLICY CMP0083)
  cmake_policy(SET CMP0083 NEW)
endif()

# Workaround for 3.19 raising error 'IMPORTED_LOCATION not set for imported
# target "GTest::gtest_main"'.
if(POLICY CMP0111)
  cmake_policy(SET CMP0111 OLD)
endif()

project(hwy VERSION 1.0.7)  # Keep in sync with highway.h version
# `hwy` is lowercase to handle find_package() in Config mode:
set(namespace "${PROJECT_NAME}::")

# Directly define the ABI version from the cmake project() version values:
set(LIBRARY_VERSION "${hwy_VERSION}")
set(LIBRARY_SOVERSION ${hwy_VERSION_MAJOR})

set(CMAKE_CXX_EXTENSIONS OFF)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
# Search for Atomics implementation:
find_package(Atomics REQUIRED)

# Enabled PIE binaries by default if supported.
include(CheckPIESupported OPTIONAL RESULT_VARIABLE CHECK_PIE_SUPPORTED)
if(CHECK_PIE_SUPPORTED)
  check_pie_supported(LANGUAGES CXX)
  if(CMAKE_CXX_LINK_PIE_SUPPORTED)
    set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
  endif()
endif()

include(GNUInstallDirs)

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

# The following is only required with GCC < 6.1.0 or CLANG < 16.0
set(HWY_CMAKE_ARM7 OFF CACHE BOOL "Set copts for Armv7 with NEON (requires vfpv4)?")

# This must be set on 32-bit x86 with GCC < 13.1, otherwise math_test will be
# skipped. For GCC 13.1+, you can also build with -fexcess-precision=standard.
set(HWY_CMAKE_SSE2 OFF CACHE BOOL "Set SSE2 as baseline for 32-bit x86?")

# Unconditionally adding -Werror risks breaking the build when new warnings
# arise due to compiler/platform changes. Enable this in CI/tests.
set(HWY_WARNINGS_ARE_ERRORS OFF CACHE BOOL "Add -Werror flag?")

set(HWY_ENABLE_CONTRIB ON CACHE BOOL "Include contrib/")
set(HWY_ENABLE_EXAMPLES ON CACHE BOOL "Build examples")
set(HWY_ENABLE_INSTALL ON CACHE BOOL "Install library")
set(HWY_ENABLE_TESTS ON CACHE BOOL "Enable HWY tests")

include(CheckCXXSourceCompiles)
check_cxx_source_compiles(
   "int main() {
      #if !defined(__EMSCRIPTEN__)
      static_assert(false, \"__EMSCRIPTEN__ is not defined\");
      #endif
      return 0;
    }"
  HWY_EMSCRIPTEN
)

check_cxx_source_compiles(
   "int main() {
      #if !defined(__riscv)
      static_assert(false, \"__riscv is not defined\");
      #endif
      return 0;
    }"
  HWY_RISCV
)

if (HWY_ENABLE_CONTRIB)
# Glob all the traits so we don't need to modify this file when adding
# additional special cases.
file(GLOB HWY_CONTRIB_SOURCES "hwy/contrib/sort/vqsort_*.cc")
list(APPEND HWY_CONTRIB_SOURCES
    hwy/contrib/dot/dot-inl.h
    hwy/contrib/image/image.cc
    hwy/contrib/image/image.h
    hwy/contrib/math/math-inl.h
    hwy/contrib/sort/order.h
    hwy/contrib/sort/shared-inl.h
    hwy/contrib/sort/sorting_networks-inl.h
    hwy/contrib/sort/traits-inl.h
    hwy/contrib/sort/traits128-inl.h
    hwy/contrib/sort/vqsort-inl.h
    hwy/contrib/sort/vqsort.cc
    hwy/contrib/sort/vqsort.h
    hwy/contrib/algo/copy-inl.h
    hwy/contrib/algo/find-inl.h
    hwy/contrib/algo/transform-inl.h
    hwy/contrib/unroller/unroller-inl.h
)
endif()  # HWY_ENABLE_CONTRIB

set(HWY_SOURCES
    hwy/aligned_allocator.cc
    hwy/aligned_allocator.h
    hwy/base.h
    hwy/cache_control.h
    hwy/detect_compiler_arch.h  # private
    hwy/detect_targets.h  # private
    hwy/foreach_target.h
    hwy/highway.h
    hwy/highway_export.h
    hwy/nanobenchmark.cc
    hwy/nanobenchmark.h
    hwy/ops/arm_neon-inl.h
    hwy/ops/arm_sve-inl.h
    hwy/ops/emu128-inl.h
    hwy/ops/generic_ops-inl.h
    hwy/ops/ppc_vsx-inl.h
    hwy/ops/rvv-inl.h
    hwy/ops/scalar-inl.h
    hwy/ops/set_macros-inl.h
    hwy/ops/shared-inl.h
    hwy/ops/wasm_128-inl.h
    hwy/ops/tuple-inl.h
    hwy/ops/x86_128-inl.h
    hwy/ops/x86_256-inl.h
    hwy/ops/x86_512-inl.h
    hwy/per_target.cc
    hwy/per_target.h
    hwy/print-inl.h
    hwy/print.cc
    hwy/print.h
    hwy/robust_statistics.h
    hwy/targets.cc
    hwy/targets.h
    hwy/timer.cc
    hwy/timer.h
    hwy/timer-inl.h
)

set(HWY_TEST_SOURCES
    hwy/tests/hwy_gtest.h
    hwy/tests/test_util-inl.h
    hwy/tests/test_util.cc
    hwy/tests/test_util.h
)

if (MSVC)
  set(HWY_FLAGS
    # fix build error C1128 in blockwise*_test & arithmetic_test
    /bigobj
  )
else()
  set(HWY_FLAGS
    # Avoid changing binaries based on the current time and date.
    -Wno-builtin-macro-redefined
    -D__DATE__="redacted"
    -D__TIMESTAMP__="redacted"
    -D__TIME__="redacted"

    # Optimizations
    -fmerge-all-constants

    # Warnings
    -Wall
    -Wextra
    # These are not included in Wall nor Wextra:
    -Wconversion
    -Wsign-conversion
    -Wvla
    -Wnon-virtual-dtor
  )

  if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
    list(APPEND HWY_FLAGS
      -Wfloat-overflow-conversion
      -Wfloat-zero-conversion
      -Wfor-loop-analysis
      -Wgnu-redeclared-enum
      -Winfinite-recursion
      -Wself-assign
      -Wstring-conversion
      -Wtautological-overlap-compare
      -Wthread-safety-analysis
      -Wundefined-func-template

      -fno-cxx-exceptions
      -fno-slp-vectorize
      -fno-vectorize

      # Use color in messages
      -fdiagnostics-show-option -fcolor-diagnostics
    )
    if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 6.0)
      list(APPEND HWY_FLAGS -Wc++2a-extensions)
    endif()
  endif()

  if (WIN32)
    if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
      list(APPEND HWY_FLAGS
        -Wno-global-constructors
        -Wno-language-extension-token
        -Wno-used-but-marked-unused
        -Wno-shadow-field-in-constructor
        -Wno-unused-member-function
        -Wno-unused-template
        -Wno-c++98-compat-pedantic
        -Wno-used-but-marked-unused
        -Wno-zero-as-null-pointer-constant
      )
    endif()

    list(APPEND HWY_FLAGS
      -Wno-cast-align
      -Wno-double-promotion
      -Wno-float-equal
      -Wno-format-nonliteral
      -Wno-shadow
      -Wno-sign-conversion
    )
  else()
    list(APPEND HWY_FLAGS
      -fmath-errno
      -fno-exceptions
    )
  endif()  # WIN32

  # Workaround for excess precision, see #1488.
  if (HWY_CMAKE_SSE2)
    list(APPEND HWY_FLAGS -msse2 -mfpmath=sse)
  endif()

  if (HWY_CMAKE_ARM7)
    list(APPEND HWY_FLAGS
      -march=armv7-a
      -mfpu=neon-vfpv4
      -mfloat-abi=hard  # must match the toolchain specified as CXX=
      -mfp16-format=ieee  # required for vcvt_f32_f16
    )
  endif()  # HWY_CMAKE_ARM7

  if(HWY_RISCV)
    # gcc(13) and recent clang both support V, but not yet runtime dispatch, so
    # we add the gcv compiler flag, which then requires the CPU (now when using
    # either compiler) to support V.
    list(APPEND HWY_FLAGS -march=rv64gcv1p0)
    if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
      list(APPEND HWY_FLAGS -menable-experimental-extensions)
    endif()
  endif()

  if (HWY_WARNINGS_ARE_ERRORS)
    list(APPEND HWY_FLAGS -Werror)
  endif()

  # Prevent "wasm-ld: error: --shared-memory is disallowed by targets.cc.o
  # because it was not compiled with 'atomics' or 'bulk-memory' features."
  if (HWY_EMSCRIPTEN)
    list(APPEND HWY_FLAGS -matomics)
  endif()

endif()  # !MSVC

include(CheckIncludeFile)
check_include_file(sys/auxv.h  HAVE_SYS_AUXV_H)
check_include_file(asm/hwcap.h HAVE_ASM_HWCAP_H)

# By default prefer STATIC build (legacy behavior)
option(BUILD_SHARED_LIBS "Build shared libraries" OFF)
option(HWY_FORCE_STATIC_LIBS "Ignore BUILD_SHARED_LIBS" OFF)
# only expose shared/static options to advanced users:
mark_as_advanced(BUILD_SHARED_LIBS)
mark_as_advanced(HWY_FORCE_STATIC_LIBS)
# Define visibility settings globally:
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

# Copy-cat "add_library" logic + add override.
set(HWY_LIBRARY_TYPE "SHARED")
if (NOT BUILD_SHARED_LIBS OR HWY_FORCE_STATIC_LIBS)
  set(HWY_LIBRARY_TYPE "STATIC")
endif()

# This preprocessor define will drive the build, also used in the *.pc files:
if("${HWY_LIBRARY_TYPE}" STREQUAL "SHARED")
  set(DLLEXPORT_TO_DEFINE "HWY_SHARED_DEFINE")
else()
  set(DLLEXPORT_TO_DEFINE "HWY_STATIC_DEFINE")
endif()

add_library(hwy ${HWY_LIBRARY_TYPE} ${HWY_SOURCES})
if(NOT HAVE_SYS_AUXV_H)
  target_compile_definitions(hwy PUBLIC TOOLCHAIN_MISS_SYS_AUXV_H)
endif()
if(NOT HAVE_ASM_HWCAP_H)
  target_compile_definitions(hwy PUBLIC TOOLCHAIN_MISS_ASM_HWCAP_H)
endif()
target_compile_definitions(hwy PUBLIC "${DLLEXPORT_TO_DEFINE}")
target_compile_options(hwy PRIVATE ${HWY_FLAGS})
set_property(TARGET hwy PROPERTY POSITION_INDEPENDENT_CODE ON)
set_target_properties(hwy PROPERTIES VERSION ${LIBRARY_VERSION} SOVERSION ${LIBRARY_SOVERSION})
target_include_directories(hwy PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
target_compile_features(hwy PUBLIC cxx_std_11)
set_target_properties(hwy PROPERTIES
  LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version)
# For GCC __atomic_store_8, see #887
target_link_libraries(hwy PRIVATE ${ATOMICS_LIBRARIES})
# not supported by MSVC/Clang, safe to skip (we use DLLEXPORT annotations)
if(UNIX AND NOT APPLE)
  set_property(TARGET hwy APPEND_STRING PROPERTY
    LINK_FLAGS " -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version")
endif()

if (HWY_ENABLE_CONTRIB)
add_library(hwy_contrib ${HWY_LIBRARY_TYPE} ${HWY_CONTRIB_SOURCES})
target_link_libraries(hwy_contrib PUBLIC hwy)
target_compile_options(hwy_contrib PRIVATE ${HWY_FLAGS})
set_property(TARGET hwy_contrib PROPERTY POSITION_INDEPENDENT_CODE ON)
set_target_properties(hwy_contrib PROPERTIES VERSION ${LIBRARY_VERSION} SOVERSION ${LIBRARY_SOVERSION})
target_include_directories(hwy_contrib PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
target_compile_features(hwy_contrib PUBLIC cxx_std_11)
set_target_properties(hwy_contrib PROPERTIES
  LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version)
# For GCC __atomic_store_8, see #887
target_link_libraries(hwy_contrib PRIVATE ${ATOMICS_LIBRARIES})
# not supported by MSVC/Clang, safe to skip (we use DLLEXPORT annotations)
if(UNIX AND NOT APPLE)
  set_property(TARGET hwy_contrib APPEND_STRING PROPERTY
    LINK_FLAGS " -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version")
endif()
endif()  # HWY_ENABLE_CONTRIB

add_library(hwy_test ${HWY_LIBRARY_TYPE} ${HWY_TEST_SOURCES})
target_link_libraries(hwy_test PUBLIC hwy)
target_compile_options(hwy_test PRIVATE ${HWY_FLAGS})
set_property(TARGET hwy_test PROPERTY POSITION_INDEPENDENT_CODE ON)
set_target_properties(hwy_test PROPERTIES VERSION ${LIBRARY_VERSION} SOVERSION ${LIBRARY_SOVERSION})
target_include_directories(hwy_test PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
target_compile_features(hwy_test PUBLIC cxx_std_11)
set_target_properties(hwy_test PROPERTIES
  LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version)
# not supported by MSVC/Clang, safe to skip (we use DLLEXPORT annotations)
if(UNIX AND NOT APPLE)
  set_property(TARGET hwy_test APPEND_STRING PROPERTY
    LINK_FLAGS " -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version")
endif()

# -------------------------------------------------------- hwy_list_targets
# Generate a tool to print the compiled-in targets as defined by the current

=== debian/changelog ===
highway (1.0.7-7) unstable; urgency=medium

  * d/rules: Do not build EMU128 code
  * d/patches: Really fix ppc10/htm issue

 -- Mathieu Malaterre <malat@debian.org>  Fri, 15 Sep 2023 11:47:57 +0200

highway (1.0.7-6) unstable; urgency=medium

  * d/patches: workaround for inlining error on ppc64el
  * d/rules: Run armhf/neon test suite

 -- Mathieu Malaterre <malat@debian.org>  Thu, 14 Sep 2023 14:45:34 +0200

highway (1.0.7-5) unstable; urgency=medium

  * d/patches: Workaround for ppc64el/lto
  * d/rules: Run math_test on i386 cpus

 -- Mathieu Malaterre <malat@debian.org>  Thu, 14 Sep 2023 08:26:21 +0200

highway (1.0.7-4) unstable; urgency=medium

  * d/patches: Workaround to current RVV/GCC-13 limitation
  * d/patches: Remove extra ppc64el patch not needed

 -- Mathieu Malaterre <malat@debian.org>  Wed, 13 Sep 2023 08:43:20 +0200

highway (1.0.7-3) unstable; urgency=medium

  * d/patches: fix compilation with LTO
  * d/rules: Workaround for loong64 and old GCC 12.x
  * d/rules: Start building with LTO
  * d/rules: Start building highway with g++-13 on most arches
  * d/control: Add explicit highway keyword. Closes: #1051450

 -- Mathieu Malaterre <malat@debian.org>  Tue, 12 Sep 2023 08:45:41 +0200

highway (1.0.7-2) unstable; urgency=medium

  * d/patches: Fix make test on i386
  * d/rules: Prefer g++-12 for now. See #1050933

 -- Mathieu Malaterre <malat@debian.org>  Thu, 31 Aug 2023 16:20:57 +0200

highway (1.0.7-1) unstable; urgency=medium

  * New upstream version 1.0.7
  * d/patches: Fixes for float16_t/bfloat16_t operator++ and operator--
  * d/rules: Fix armhf neon-less system. Closes: #1033656

 -- Mathieu Malaterre <malat@debian.org>  Thu, 31 Aug 2023 12:09:44 +0200

highway (1.0.6-1) unstable; urgency=medium

  * d/install: Run wrap-and-sort
  * New upstream version 1.0.6

 -- Mathieu Malaterre <malat@debian.org>  Sat, 26 Aug 2023 14:00:06 +0200

highway (1.0.5-1) unstable; urgency=medium

  * New upstream version 1.0.5
  * d/symbols: Add missing symbols

 -- Mathieu Malaterre <malat@debian.org>  Wed, 23 Aug 2023 11:39:21 +0200

highway (1.0.4-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable)

  [ Mathieu Malaterre ]
  * New upstream version 1.0.4
  * d/patches: Remove patches applied upstream

 -- Mathieu Malaterre <malat@debian.org>  Tue, 22 Aug 2023 13:11:58 +0200

=== debian/control ===
Source: highway
Section: libs
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>
Build-Depends: cmake, debhelper (>= 11), g++-12, libgtest-dev, ninja-build
Build-Depends-Indep: ghostscript
Standards-Version: 4.6.2
Homepage: https://github.com/google/highway
Vcs-Git: https://salsa.debian.org/debian-phototools-team/highway.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/highway
Rules-Requires-Root: no

Package: libhwy1
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Efficient and performance-portable SIMD wrapper (runtime files)
 This library provides type-safe and source-code portable wrappers over
 existing platform-specific intrinsics. Its design aims for simplicity,
 reliable efficiency across platforms, and immediate usability with current
 compilers.
 .
 This package installs the highway runtime files.

Package: libhwy-dev
Architecture: any
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: libhwy1 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Efficient and performance-portable SIMD wrapper (developer files)
 This library provides type-safe and source-code portable wrappers over
 existing platform-specific intrinsics. Its design aims for simplicity,
 reliable efficiency across platforms, and immediate usability with current
 compilers.
 .
 This package installs the highway development files.

Package: highway-doc
Architecture: all
Section: doc
Depends: doc-base, ${misc:Depends}
Description: Efficient and performance-portable SIMD wrapper (documentation files)
 This library provides type-safe and source-code portable wrappers over
 existing platform-specific intrinsics. Its design aims for simplicity,
 reliable efficiency across platforms, and immediate usability with current
 compilers.
 .
 This package installs the highway documentation files.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

%:
	dh $@ --buildsystem=cmake+ninja

# Remove EMU128 for now
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=111231
# Let's pretend to know what we are doing:
#DEB_CXXFLAGS_MAINT_APPEND += -DHWY_BROKEN_EMU128=0

ifneq (,$(filter $(DEB_HOST_ARCH), armel armhf))
  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728
  DEB_CXXFLAGS_MAINT_APPEND += -Wno-psabi
endif

ifneq (,$(filter $(DEB_HOST_ARCH), loong64))
  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=106322
  DEB_CXXFLAGS_MAINT_APPEND += -fno-tree-vectorize
endif

ifeq ($(DEB_HOST_ARCH_CPU),i386)
  # https://github.com/google/highway/issues/1488
  DEB_CXXFLAGS_MAINT_APPEND += -fexcess-precision=standard
endif

ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),armhf))
  # https://github.com/google/highway/issues/1271
  CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=ON
endif

ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),riscv64))
  # https://github.com/google/highway/issues/1740
  CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_RVV:BOOL=OFF
endif

include /usr/share/dpkg/buildtools.mk

ifneq (,$(filter $(DEB_HOST_ARCH), arm64 armhf))
  CC=gcc-12
  CXX=g++-12
  export CC
  export CXX
endif

export DEB_CXXFLAGS_MAINT_APPEND

# test suite rely on CMAKE_SKIP_RPATH=OFF
CMAKE_EXTRA_FLAGS += \
 -DCMAKE_SKIP_RPATH:BOOL=OFF \
 -DBUILD_SHARED_LIBS:BOOL=ON \
 -DHWY_WARNINGS_ARE_ERRORS:BOOL=ON \
 -DHWY_SYSTEM_GTEST:BOOL=ON

ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
CMAKE_EXTRA_FLAGS += -DBUILD_TESTING=OFF
endif

override_dh_auto_configure-arch:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_install-arch:
ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),armhf))
	sed -i -e 's/HWY_CMAKE_ARM7:BOOL=ON/HWY_CMAKE_ARM7:BOOL=OFF/' obj-*/CMakeCache.txt
endif
	dh_auto_install

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
# run default example to check compilation ok:
override_dh_install-arch:
ifeq (,$(filter $(DEB_BUILD_ARCH),hurd-i386))
	obj-*/examples/hwy_benchmark
else
	echo "CPU 'QEMU Virtual CPU version 2.5+' does not support RDTSCP, skipping benchmark."
endif
	dh_install
endif

override_dh_clean-indep:
	dh_clean debian_docs/

override_dh_auto_configure-indep:
override_dh_auto_build-indep:
	# most docs are ok as-is
	cp -a g3doc debian_docs
	# let's shrink a bit this one:
	gs  -q -dNOPAUSE -dBATCH -dSAFER \
		-sDEVICE=pdfwrite \
		-dCompatibilityLevel=1.4 \
		-dPDFSETTINGS=/screen \
		-dEmbedAllFonts=true \
		-dSubsetFonts=true \
		-dColorImageDownsampleType=/Bicubic \
		-dColorImageResolution=72 \
		-dGrayImageDownsampleType=/Bicubic \
		-dGrayImageResolution=72 \
		-dMonoImageDownsampleType=/Bicubic \
		-dMonoImageResolution=72 \
		-sOutputFile=debian_docs/highway_intro.pdf ./g3doc/highway_intro.pdf

override_dh_auto_test-indep:
override_dh_auto_install-indep:
override_dh_compress-indep:
	# do not compress .pdf/.md files for documentation
	dh_compress -X.md -X.pdf

## highway 1.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,15 @@
   cmake_policy(SET CMP0111 OLD)
 endif()
 
-project(hwy VERSION 1.0.7)  # Keep in sync with highway.h version
+# Starting with GCC-13, we want to make sure to remove gnu extension (ie.
+# explicit -std=c++17 instead of implicit `gnu++17`)
+# Without this cmake property, CMAKE_CXX_EXTENSIONS=OFF was not properly
+# considered
+if(POLICY CMP0128)
+  cmake_policy(SET CMP0128 NEW)
+endif()
+
+project(hwy VERSION 1.1.0)  # Keep in sync with highway.h version
 # `hwy` is lowercase to handle find_package() in Config mode:
 set(namespace "${PROJECT_NAME}::")
 
@@ -60,6 +68,9 @@
 # This must be set on 32-bit x86 with GCC < 13.1, otherwise math_test will be
 # skipped. For GCC 13.1+, you can also build with -fexcess-precision=standard.
 set(HWY_CMAKE_SSE2 OFF CACHE BOOL "Set SSE2 as baseline for 32-bit x86?")
+
+# Currently this will compile the entire codebase with `-march=rv64gcv1p0`:
+set(HWY_CMAKE_RVV ON CACHE BOOL "Set copts for RISCV with RVV?")
 
 # Unconditionally adding -Werror risks breaking the build when new warnings
 # arise due to compiler/platform changes. Enable this in CI/tests.
@@ -100,6 +111,7 @@
     hwy/contrib/image/image.cc
     hwy/contrib/image/image.h
     hwy/contrib/math/math-inl.h
+    hwy/contrib/matvec/matvec-inl.h
     hwy/contrib/sort/order.h
     hwy/contrib/sort/shared-inl.h
     hwy/contrib/sort/sorting_networks-inl.h
@@ -108,6 +120,8 @@
     hwy/contrib/sort/vqsort-inl.h
     hwy/contrib/sort/vqsort.cc
     hwy/contrib/sort/vqsort.h
+    hwy/contrib/thread_pool/futex.h
+    hwy/contrib/thread_pool/thread_pool.h
     hwy/contrib/algo/copy-inl.h
     hwy/contrib/algo/find-inl.h
     hwy/contrib/algo/transform-inl.h
@@ -127,6 +141,7 @@
     hwy/highway_export.h
     hwy/nanobenchmark.cc
     hwy/nanobenchmark.h
+    hwy/profiler.h
     hwy/ops/arm_neon-inl.h
     hwy/ops/arm_sve-inl.h
     hwy/ops/emu128-inl.h
@@ -247,22 +262,41 @@
     list(APPEND HWY_FLAGS -msse2 -mfpmath=sse)
   endif()
 
+  # Suppress STL iterator warnings. Supported by GCC 4.4.7 and newer, which
+  # predates the C++11 we require.
+  if (${CMAKE_CXX_COMPILER_ID} MATCHES "GNU")
+    list(APPEND HWY_FLAGS -Wno-psabi)
+  endif()
+  # Clang supports this flag from 11.0.
+  if (${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
+    if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 11.0)
+      list(APPEND HWY_FLAGS -Wno-psabi)
+    endif()
+  endif()
+
   if (HWY_CMAKE_ARM7)
     list(APPEND HWY_FLAGS
       -march=armv7-a
       -mfpu=neon-vfpv4
       -mfloat-abi=hard  # must match the toolchain specified as CXX=
-      -mfp16-format=ieee  # required for vcvt_f32_f16
     )
+    if(${CMAKE_CXX_COMPILER_ID} MATCHES "GNU")
+      # using GCC
+      list(APPEND HWY_FLAGS
+        -mfp16-format=ieee  # required for vcvt_f32_f16
+      )
+    endif()
   endif()  # HWY_CMAKE_ARM7
 
   if(HWY_RISCV)
     # gcc(13) and recent clang both support V, but not yet runtime dispatch, so
     # we add the gcv compiler flag, which then requires the CPU (now when using
     # either compiler) to support V.
-    list(APPEND HWY_FLAGS -march=rv64gcv1p0)
-    if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
-      list(APPEND HWY_FLAGS -menable-experimental-extensions)
+    if(HWY_CMAKE_RVV)
+      list(APPEND HWY_FLAGS -march=rv64gcv1p0)
+      if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
+        list(APPEND HWY_FLAGS -menable-experimental-extensions)
+      endif()
     endif()
   endif()
 
@@ -347,26 +381,3 @@
 # not supported by MSVC/Clang, safe to skip (we use DLLEXPORT annotations)
 if(UNIX AND NOT APPLE)
   set_property(TARGET hwy_contrib APPEND_STRING PROPERTY
-    LINK_FLAGS " -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version")
-endif()
-endif()  # HWY_ENABLE_CONTRIB
-
-add_library(hwy_test ${HWY_LIBRARY_TYPE} ${HWY_TEST_SOURCES})
-target_link_libraries(hwy_test PUBLIC hwy)
-target_compile_options(hwy_test PRIVATE ${HWY_FLAGS})
-set_property(TARGET hwy_test PROPERTY POSITION_INDEPENDENT_CODE ON)
-set_target_properties(hwy_test PROPERTIES VERSION ${LIBRARY_VERSION} SOVERSION ${LIBRARY_SOVERSION})
-target_include_directories(hwy_test PUBLIC
-    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
-    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
-target_compile_features(hwy_test PUBLIC cxx_std_11)
-set_target_properties(hwy_test PROPERTIES
-  LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version)
-# not supported by MSVC/Clang, safe to skip (we use DLLEXPORT annotations)
-if(UNIX AND NOT APPLE)
-  set_property(TARGET hwy_test APPEND_STRING PROPERTY
-    LINK_FLAGS " -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version")
-endif()
-
-# -------------------------------------------------------- hwy_list_targets
-# Generate a tool to print the compiled-in targets as defined by the current

=== debian/changelog ===
highway (1.1.0-3) unstable; urgency=medium

  * d/rules: Use PDF 1.5
  * d/rules: Really fix armhf buildd
  * d/rules: Fix compilation on i386

 -- Mathieu Malaterre <malat@debian.org>  Wed, 29 May 2024 19:10:36 +0200

highway (1.1.0-2) unstable; urgency=medium

  * d/symbols: Fix lintian error
  * d/patches: Allow AVX2 on x86
  * d/rules: Reduce optimization on armhf
  * d/patches: Fix compilation on Hurd

 -- Mathieu Malaterre <malat@debian.org>  Wed, 29 May 2024 08:52:30 +0200

highway (1.1.0-1) unstable; urgency=medium

  * d/rules: loong64 has switched to GCC-13
  * New upstream version 1.1.0
  * d/symbols: Add new symbol
  * d/patches: Refresh patches

 -- Mathieu Malaterre <malat@debian.org>  Fri, 24 May 2024 13:22:20 +0200

highway (1.0.7-8.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062340

 -- Lukas Märdian <slyon@debian.org>  Wed, 28 Feb 2024 10:28:57 +0000

highway (1.0.7-8) unstable; urgency=medium

  * d/rules: Remove gcc-12 workaround
  * d/patches: Fix bug on aarch64+emu128
  * d/rules: Prefer EMU128 over SCALAR

 -- Mathieu Malaterre <malat@debian.org>  Fri, 06 Oct 2023 09:30:48 +0200

=== debian/rules ===
--- 
+++ 
@@ -9,29 +9,30 @@
 %:
 	dh $@ --buildsystem=cmake+ninja
 
-# Remove EMU128 for now
-# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=111231
 # Let's pretend to know what we are doing:
-#DEB_CXXFLAGS_MAINT_APPEND += -DHWY_BROKEN_EMU128=0
+DEB_CXXFLAGS_MAINT_APPEND += -DHWY_BROKEN_EMU128=0
 
 ifneq (,$(filter $(DEB_HOST_ARCH), armel armhf))
   # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728
   DEB_CXXFLAGS_MAINT_APPEND += -Wno-psabi
 endif
 
-ifneq (,$(filter $(DEB_HOST_ARCH), loong64))
-  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=106322
-  DEB_CXXFLAGS_MAINT_APPEND += -fno-tree-vectorize
-endif
-
 ifeq ($(DEB_HOST_ARCH_CPU),i386)
   # https://github.com/google/highway/issues/1488
   DEB_CXXFLAGS_MAINT_APPEND += -fexcess-precision=standard
+  # https://github.com/google/highway/issues/2208
+  DEB_CXXFLAGS_MAINT_APPEND += --param ggc-min-expand=10
 endif
 
 ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),armhf))
   # https://github.com/google/highway/issues/1271
   CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=ON
+  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=111231
+  DEB_CXXFLAGS_MAINT_APPEND += -fno-tree-vectorize
+  # https://github.com/google/highway/issues/2200
+  DEB_CXXFLAGS_MAINT_APPEND += -O1
+  # Switching to O1 generate a different error than O2, prefer O0:
+  DEB_CXXFLAGS_MAINT_APPEND += -O0
 endif
 
 ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),riscv64))
@@ -40,13 +41,6 @@
 endif
 
 include /usr/share/dpkg/buildtools.mk
-
-ifneq (,$(filter $(DEB_HOST_ARCH), arm64 armhf))
-  CC=gcc-12
-  CXX=g++-12
-  export CC
-  export CXX
-endif
 
 export DEB_CXXFLAGS_MAINT_APPEND
 
@@ -91,7 +85,7 @@
 	# let's shrink a bit this one:
 	gs  -q -dNOPAUSE -dBATCH -dSAFER \
 		-sDEVICE=pdfwrite \
-		-dCompatibilityLevel=1.4 \
+		-dCompatibilityLevel=1.5 \
 		-dPDFSETTINGS=/screen \
 		-dEmbedAllFonts=true \
 		-dSubsetFonts=true \

## highway 1.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,7 @@
 # Copyright 2019 Google LLC
+# Copyright 2024 Arm Limited and/or its affiliates <open-source-office@arm.com>
+# SPDX-License-Identifier: Apache-2.0
+# SPDX-License-Identifier: BSD-3-Clause
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -33,7 +36,7 @@
   cmake_policy(SET CMP0128 NEW)
 endif()
 
-project(hwy VERSION 1.1.0)  # Keep in sync with highway.h version
+project(hwy VERSION 1.2.0)  # Keep in sync with base.h version
 # `hwy` is lowercase to handle find_package() in Config mode:
 set(namespace "${PROJECT_NAME}::")
 
@@ -76,10 +79,35 @@
 # arise due to compiler/platform changes. Enable this in CI/tests.
 set(HWY_WARNINGS_ARE_ERRORS OFF CACHE BOOL "Add -Werror flag?")
 
+# Experimental support for header-only builds
+set(HWY_CMAKE_HEADER_ONLY OFF CACHE BOOL "Change to header-only?")
+
 set(HWY_ENABLE_CONTRIB ON CACHE BOOL "Include contrib/")
 set(HWY_ENABLE_EXAMPLES ON CACHE BOOL "Build examples")
 set(HWY_ENABLE_INSTALL ON CACHE BOOL "Install library")
 set(HWY_ENABLE_TESTS ON CACHE BOOL "Enable HWY tests")
+
+if (NOT DEFINED CMAKE_CXX_STANDARD)
+  if ("cxx_std_17" IN_LIST CMAKE_CXX_COMPILE_FEATURES)
+    set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_17)
+  else()
+    if ("cxx_std_14" IN_LIST CMAKE_CXX_COMPILE_FEATURES)
+      set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_14)
+    else()
+      set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_11)
+    endif()
+  endif()
+else()
+  if (CMAKE_CXX_STANDARD GREATER_EQUAL 14 AND CMAKE_CXX_STANDARD LESS 98)
+    if (CMAKE_CXX_STANDARD GREATER_EQUAL 17)
+      set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_17)
+    else()
+      set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_14)
+    endif()
+  else()
+    set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_11)
+  endif()
+endif()
 
 include(CheckCXXSourceCompiles)
 check_cxx_source_compiles(
@@ -107,11 +135,13 @@
 # additional special cases.
 file(GLOB HWY_CONTRIB_SOURCES "hwy/contrib/sort/vqsort_*.cc")
 list(APPEND HWY_CONTRIB_SOURCES
+    hwy/contrib/bit_pack/bit_pack-inl.h
     hwy/contrib/dot/dot-inl.h
     hwy/contrib/image/image.cc
     hwy/contrib/image/image.h
     hwy/contrib/math/math-inl.h
     hwy/contrib/matvec/matvec-inl.h
+    hwy/contrib/random/random-inl.h
     hwy/contrib/sort/order.h
     hwy/contrib/sort/shared-inl.h
     hwy/contrib/sort/sorting_networks-inl.h
@@ -122,6 +152,8 @@
     hwy/contrib/sort/vqsort.h
     hwy/contrib/thread_pool/futex.h
     hwy/contrib/thread_pool/thread_pool.h
+    hwy/contrib/thread_pool/topology.cc
+    hwy/contrib/thread_pool/topology.h
     hwy/contrib/algo/copy-inl.h
     hwy/contrib/algo/find-inl.h
     hwy/contrib/algo/transform-inl.h
@@ -130,44 +162,51 @@
 endif()  # HWY_ENABLE_CONTRIB
 
 set(HWY_SOURCES
-    hwy/aligned_allocator.cc
+    hwy/abort.h
     hwy/aligned_allocator.h
     hwy/base.h
     hwy/cache_control.h
     hwy/detect_compiler_arch.h  # private
     hwy/detect_targets.h  # private
     hwy/foreach_target.h
+    hwy/highway_export.h
     hwy/highway.h
-    hwy/highway_export.h
-    hwy/nanobenchmark.cc
     hwy/nanobenchmark.h
-    hwy/profiler.h
     hwy/ops/arm_neon-inl.h
     hwy/ops/arm_sve-inl.h
     hwy/ops/emu128-inl.h
     hwy/ops/generic_ops-inl.h
+    hwy/ops/inside-inl.h
     hwy/ops/ppc_vsx-inl.h
     hwy/ops/rvv-inl.h
     hwy/ops/scalar-inl.h
     hwy/ops/set_macros-inl.h
     hwy/ops/shared-inl.h
     hwy/ops/wasm_128-inl.h
-    hwy/ops/tuple-inl.h
     hwy/ops/x86_128-inl.h
     hwy/ops/x86_256-inl.h
     hwy/ops/x86_512-inl.h
-    hwy/per_target.cc
     hwy/per_target.h
     hwy/print-inl.h
+    hwy/print.h
+    hwy/profiler.h
+    hwy/robust_statistics.h
+    hwy/targets.h
+    hwy/timer-inl.h
+    hwy/timer.h
+)
+
+if (NOT HWY_CMAKE_HEADER_ONLY)
+  list(APPEND HWY_SOURCES
+    hwy/abort.cc
+    hwy/aligned_allocator.cc
+    hwy/nanobenchmark.cc
+    hwy/per_target.cc
     hwy/print.cc
-    hwy/print.h
-    hwy/robust_statistics.h
     hwy/targets.cc
-    hwy/targets.h
     hwy/timer.cc
-    hwy/timer.h
-    hwy/timer-inl.h
-)
+  )
+endif()
 
 set(HWY_TEST_SOURCES
     hwy/tests/hwy_gtest.h
@@ -180,7 +219,52 @@
   set(HWY_FLAGS
     # fix build error C1128 in blockwise*_test & arithmetic_test
     /bigobj
+
+    # Warnings
+    /W4
+    # Disable some W4 warnings.  Enable them individually after they are cleaned up.
+    /wd4100
+    /wd4127
+    /wd4324
+    /wd4456
+    /wd4701
+    /wd4702
+    /wd4723
+
+    # CMake automatically adds exception handling flags.  Remove them.
+    /GR-
+    /EHs-c-
+    # Disable exceptions in STL code.
+    -D_HAS_EXCEPTIONS=0
   )
+
+  # This adds extra warnings for the clang-cl compiler on Windows.
+  # This is the same as the sections in the else part.
+  # These could be refactored.
+  if (${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
+    list(APPEND HWY_FLAGS
+      # These are not included in Wall nor Wextra:
+      -Wconversion
+      -Wsign-conversion
+      -Wvla
+      -Wnon-virtual-dtor
+
+      -Wfloat-overflow-conversion
+      -Wfloat-zero-conversion
+      -Wfor-loop-analysis
+      -Wgnu-redeclared-enum
+      -Winfinite-recursion
+      -Wself-assign
+      -Wstring-conversion
+      -Wtautological-overlap-compare
+      -Wthread-safety-analysis
+      -Wundefined-func-template
+    )
+  endif()
+
+  if (HWY_WARNINGS_ARE_ERRORS)
+    list(APPEND HWY_FLAGS /WX)
+  endif()
 else()
   set(HWY_FLAGS
     # Avoid changing binaries based on the current time and date.
@@ -200,6 +284,7 @@
     -Wsign-conversion
     -Wvla
     -Wnon-virtual-dtor
+    -Wcast-align # see -Wcast-align=strict on x86
   )
 
   if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
@@ -312,6 +397,10 @@
 
 endif()  # !MSVC
 
+if (HWY_CMAKE_HEADER_ONLY)
+  list(APPEND HWY_FLAGS -DHWY_HEADER_ONLY)
+endif()
+
 include(CheckIncludeFile)
 check_include_file(sys/auxv.h  HAVE_SYS_AUXV_H)
 check_include_file(asm/hwcap.h HAVE_ASM_HWCAP_H)
@@ -328,56 +417,3 @@
 
 # Copy-cat "add_library" logic + add override.
 set(HWY_LIBRARY_TYPE "SHARED")
-if (NOT BUILD_SHARED_LIBS OR HWY_FORCE_STATIC_LIBS)
-  set(HWY_LIBRARY_TYPE "STATIC")
-endif()
-
-# This preprocessor define will drive the build, also used in the *.pc files:
-if("${HWY_LIBRARY_TYPE}" STREQUAL "SHARED")
-  set(DLLEXPORT_TO_DEFINE "HWY_SHARED_DEFINE")
-else()
-  set(DLLEXPORT_TO_DEFINE "HWY_STATIC_DEFINE")
-endif()
-
-add_library(hwy ${HWY_LIBRARY_TYPE} ${HWY_SOURCES})
-if(NOT HAVE_SYS_AUXV_H)
-  target_compile_definitions(hwy PUBLIC TOOLCHAIN_MISS_SYS_AUXV_H)
-endif()
-if(NOT HAVE_ASM_HWCAP_H)
-  target_compile_definitions(hwy PUBLIC TOOLCHAIN_MISS_ASM_HWCAP_H)
-endif()
-target_compile_definitions(hwy PUBLIC "${DLLEXPORT_TO_DEFINE}")
-target_compile_options(hwy PRIVATE ${HWY_FLAGS})
-set_property(TARGET hwy PROPERTY POSITION_INDEPENDENT_CODE ON)
-set_target_properties(hwy PROPERTIES VERSION ${LIBRARY_VERSION} SOVERSION ${LIBRARY_SOVERSION})
-target_include_directories(hwy PUBLIC
-    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
-    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
-target_compile_features(hwy PUBLIC cxx_std_11)
-set_target_properties(hwy PROPERTIES
-  LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version)
-# For GCC __atomic_store_8, see #887
-target_link_libraries(hwy PRIVATE ${ATOMICS_LIBRARIES})
-# not supported by MSVC/Clang, safe to skip (we use DLLEXPORT annotations)
-if(UNIX AND NOT APPLE)
-  set_property(TARGET hwy APPEND_STRING PROPERTY
-    LINK_FLAGS " -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version")
-endif()
-
-if (HWY_ENABLE_CONTRIB)
-add_library(hwy_contrib ${HWY_LIBRARY_TYPE} ${HWY_CONTRIB_SOURCES})
-target_link_libraries(hwy_contrib PUBLIC hwy)
-target_compile_options(hwy_contrib PRIVATE ${HWY_FLAGS})
-set_property(TARGET hwy_contrib PROPERTY POSITION_INDEPENDENT_CODE ON)
-set_target_properties(hwy_contrib PROPERTIES VERSION ${LIBRARY_VERSION} SOVERSION ${LIBRARY_SOVERSION})
-target_include_directories(hwy_contrib PUBLIC
-    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
-    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
-target_compile_features(hwy_contrib PUBLIC cxx_std_11)
-set_target_properties(hwy_contrib PROPERTIES
-  LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version)
-# For GCC __atomic_store_8, see #887
-target_link_libraries(hwy_contrib PRIVATE ${ATOMICS_LIBRARIES})
-# not supported by MSVC/Clang, safe to skip (we use DLLEXPORT annotations)
-if(UNIX AND NOT APPLE)
-  set_property(TARGET hwy_contrib APPEND_STRING PROPERTY

=== debian/changelog ===
highway (1.2.0-5) unstable; urgency=medium

  * d/rules: Use g++-14 on riscv64 for now

 -- Mathieu Malaterre <malat@debian.org>  Sun, 09 Nov 2025 17:44:55 +0100

highway (1.2.0-4) unstable; urgency=medium

  [ Simon Chopin ]
  * Cherry-pick an upstream patch to fix GCC15 build for ppc64el (LP: #2124959)
  * Force use of GCC 14 on ppc64el to work around codegen issue (LP: #2121375)
  * Disable LTO on riscv64 to work around GCC15 build issue (LP: #2121375)

 -- Mathieu Malaterre <malat@debian.org>  Thu, 06 Nov 2025 22:08:53 +0100

highway (1.2.0-3) unstable; urgency=medium

  [ Jeremy Bícha ]
  * Use Build-Depends-Package
  * Bump debhelper compat to 13
  * Drop obsolete Pre-Depends

  [ Nathan Pratta Teodosio ]
  * Add autopkgtest. (Closes: #1076436)

 -- Mathieu Malaterre <malat@debian.org>  Wed, 05 Nov 2025 15:03:39 +0100

highway (1.2.0-2) unstable; urgency=medium

  * d/patches: Import upstream fix to fix failing test
  * d/patches: Fix building on riscv64
  * d/rules: Re-allow default i386 flags

 -- Mathieu Malaterre <malat@debian.org>  Mon, 10 Jun 2024 17:52:26 +0200

highway (1.2.0-1) unstable; urgency=medium

  [ Mathieu Malaterre ]
  * New upstream version 1.2.0
  * d/patches: Refresh patches for new release
  * d/symbols: Update symbol file

  [ Stephen Kitt ]
  * d/lintian: Fix package-name-doesnt-match-sonames

 -- Mathieu Malaterre <malat@debian.org>  Mon, 10 Jun 2024 13:16:09 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,12 @@
 Priority: optional
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Mathieu Malaterre <malat@debian.org>
-Build-Depends: cmake, debhelper (>= 11), g++-12, libgtest-dev, ninja-build
+Build-Depends: cmake,
+               debhelper-compat (= 13),
+               dpkg-dev (>= 1.22.5),
+               g++-14 [ppc64el riscv64],
+               libgtest-dev,
+               ninja-build
 Build-Depends-Indep: ghostscript
 Standards-Version: 4.6.2
 Homepage: https://github.com/google/highway
@@ -11,9 +16,11 @@
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/highway
 Rules-Requires-Root: no
 
-Package: libhwy1
+Package: libhwy1t64
+Provides: ${t64:Provides}
+Replaces: libhwy1
+Breaks: libhwy1 (<< ${source:Version})
 Architecture: any
-Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Multi-Arch: same
 Description: Efficient and performance-portable SIMD wrapper (runtime files)
@@ -27,8 +34,7 @@
 Package: libhwy-dev
 Architecture: any
 Section: libdevel
-Pre-Depends: ${misc:Pre-Depends}
-Depends: libhwy1 (= ${binary:Version}), ${misc:Depends}
+Depends: libhwy1t64 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: Efficient and performance-portable SIMD wrapper (developer files)
  This library provides type-safe and source-code portable wrappers over

=== debian/rules ===
--- 
+++ 
@@ -20,8 +20,6 @@
 ifeq ($(DEB_HOST_ARCH_CPU),i386)
   # https://github.com/google/highway/issues/1488
   DEB_CXXFLAGS_MAINT_APPEND += -fexcess-precision=standard
-  # https://github.com/google/highway/issues/2208
-  DEB_CXXFLAGS_MAINT_APPEND += --param ggc-min-expand=10
 endif
 
 ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),armhf))
@@ -38,6 +36,20 @@
 ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),riscv64))
   # https://github.com/google/highway/issues/1740
   CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_RVV:BOOL=OFF
+  # LP: #2121375
+  export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
+endif
+
+ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),ppc64el))
+  # See https://github.com/google/highway/issues/2743
+  export CC=gcc-14
+  export CXX=g++-14
+endif
+
+ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),riscv64))
+  # See https://github.com/google/highway/issues/2793
+  export CC=gcc-14
+  export CXX=g++-14
 endif
 
 include /usr/share/dpkg/buildtools.mk

=== debian/tests/control ===
Tests: compile-and-execute
Depends: g++, libhwy-dev, pkgconf
Restrictions: allow-stderr

## highway 1.2.1~git20240610.f384204

=== debian/changelog ===
highway (1.2.1~git20240610.f384204-4) experimental; urgency=medium

  * d/patches: Split mul_test to allow compilation on x32
  * d/rules: Fix compilation on arm64 (no sve)

 -- Mathieu Malaterre <malat@debian.org>  Tue, 25 Jun 2024 10:54:13 +0200

highway (1.2.1~git20240610.f384204-3) experimental; urgency=medium

  * d/rules: Fix arm64 build (GCC PR/109753)
  * d/patches: Fix compilation on x32

 -- Mathieu Malaterre <malat@debian.org>  Fri, 21 Jun 2024 12:32:10 +0200

highway (1.2.1~git20240610.f384204-2) experimental; urgency=medium

  * d/patches: Do not use AES gcc option on armhf
  * d/rules: Fix compilation options on s390x

 -- Mathieu Malaterre <malat@debian.org>  Tue, 11 Jun 2024 13:55:21 +0200

highway (1.2.1~git20240610.f384204-1) experimental; urgency=medium

  * d/watch: Bump to latest version
  * New upstream version 1.2.1~git20240610.f384204
  * d/changelog: Sync from master
  * d/patches: Refresh patches

 -- Mathieu Malaterre <malat@debian.org>  Tue, 11 Jun 2024 08:32:23 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,8 @@
 Priority: optional
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Mathieu Malaterre <malat@debian.org>
-Build-Depends: cmake,
-               debhelper-compat (= 13),
-               dpkg-dev (>= 1.22.5),
-               g++-14 [ppc64el riscv64],
+Build-Depends: cmake (>= 3.13),
+               debhelper (>= 11),
                libgtest-dev,
                ninja-build
 Build-Depends-Indep: ghostscript
@@ -21,6 +19,7 @@
 Replaces: libhwy1
 Breaks: libhwy1 (<< ${source:Version})
 Architecture: any
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Multi-Arch: same
 Description: Efficient and performance-portable SIMD wrapper (runtime files)
@@ -34,6 +33,7 @@
 Package: libhwy-dev
 Architecture: any
 Section: libdevel
+Pre-Depends: ${misc:Pre-Depends}
 Depends: libhwy1t64 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: Efficient and performance-portable SIMD wrapper (developer files)

=== debian/rules ===
--- 
+++ 
@@ -15,41 +15,43 @@
 ifneq (,$(filter $(DEB_HOST_ARCH), armel armhf))
   # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728
   DEB_CXXFLAGS_MAINT_APPEND += -Wno-psabi
+  # Disable unaligned access
+  DEB_CXXFLAGS_MAINT_APPEND += -mno-unaligned-access
 endif
 
-ifeq ($(DEB_HOST_ARCH_CPU),i386)
-  # https://github.com/google/highway/issues/1488
-  DEB_CXXFLAGS_MAINT_APPEND += -fexcess-precision=standard
+ifneq (,$(filter $(DEB_HOST_ARCH), arm64))
+  # Disable unaligned access
+  DEB_CXXFLAGS_MAINT_APPEND += -mstrict-align
+  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=109753
+  DEB_CXXFLAGS_MAINT_APPEND += -march=armv8-a
+endif
+
+ifneq (,$(filter $(DEB_HOST_ARCH), loong64))
+  # Disable unaligned access
+  DEB_CXXFLAGS_MAINT_APPEND += -mstrict-align
+endif
+
+ifneq (,$(filter $(DEB_HOST_ARCH), powerpc ppc64))
+  DEB_CXXFLAGS_MAINT_APPEND += -maltivec -mcpu=power8
+  # Disable unaligned access
+  DEB_CXXFLAGS_MAINT_APPEND += -mstrict-align
+endif
+
+ifneq (,$(filter $(DEB_HOST_ARCH), s390x))
+  # To compile for Z14 or later, use the -march=z14 -mzvector compiler options.
+  DEB_CXXFLAGS_MAINT_APPEND += -march=z14 -mzvector
 endif
 
 ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),armhf))
   # https://github.com/google/highway/issues/1271
   CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=ON
-  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=111231
-  DEB_CXXFLAGS_MAINT_APPEND += -fno-tree-vectorize
-  # https://github.com/google/highway/issues/2200
-  DEB_CXXFLAGS_MAINT_APPEND += -O1
-  # Switching to O1 generate a different error than O2, prefer O0:
-  DEB_CXXFLAGS_MAINT_APPEND += -O0
 endif
 
 ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),riscv64))
   # https://github.com/google/highway/issues/1740
   CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_RVV:BOOL=OFF
-  # LP: #2121375
-  export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
-endif
-
-ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),ppc64el))
-  # See https://github.com/google/highway/issues/2743
-  export CC=gcc-14
-  export CXX=g++-14
-endif
-
-ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),riscv64))
-  # See https://github.com/google/highway/issues/2793
-  export CC=gcc-14
-  export CXX=g++-14
+  # Disable unaligned access
+  DEB_CXXFLAGS_MAINT_APPEND += -mstrict-align
 endif
 
 include /usr/share/dpkg/buildtools.mk
@@ -58,10 +60,11 @@
 
 # test suite rely on CMAKE_SKIP_RPATH=OFF
 CMAKE_EXTRA_FLAGS += \
+ -DBUILD_SHARED_LIBS:BOOL=ON \
+ -DCMAKE_BUILD_TYPE:STRING=Release \
  -DCMAKE_SKIP_RPATH:BOOL=OFF \
- -DBUILD_SHARED_LIBS:BOOL=ON \
+ -DHWY_SYSTEM_GTEST:BOOL=ON \
  -DHWY_WARNINGS_ARE_ERRORS:BOOL=ON \
- -DHWY_SYSTEM_GTEST:BOOL=ON
 
 ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 CMAKE_EXTRA_FLAGS += -DBUILD_TESTING=OFF
@@ -69,12 +72,6 @@
 
 override_dh_auto_configure-arch:
 	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)
-
-override_dh_auto_install-arch:
-ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),armhf))
-	sed -i -e 's/HWY_CMAKE_ARM7:BOOL=ON/HWY_CMAKE_ARM7:BOOL=OFF/' obj-*/CMakeCache.txt
-endif
-	dh_auto_install
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 # run default example to check compilation ok:

=== debian/watch ===
version=4
opts="mode=git,pgpmode=none,pretty=1.2.1~git%cd.%h" \
https://github.com/google/highway \
HEAD debian uupdate

## highway 1.3.0

=== debian/changelog ===
highway (1.3.0-1) unstable; urgency=medium

  * New upstream version 1.3.0
  * d/patches: Remove patches applied upstream
  * d/control: Bump Std-Vers no changes needed

 -- Mathieu Malaterre <malat@debian.org>  Wed, 03 Dec 2025 07:42:27 +0100

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,14 @@
 Priority: optional
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Mathieu Malaterre <malat@debian.org>
-Build-Depends: cmake (>= 3.13),
-               debhelper (>= 11),
+Build-Depends: cmake,
+               debhelper-compat (= 13),
+               dpkg-dev (>= 1.22.5),
+               g++-14 [ppc64el riscv64],
                libgtest-dev,
                ninja-build
 Build-Depends-Indep: ghostscript
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://github.com/google/highway
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/highway.git
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/highway
@@ -19,7 +21,6 @@
 Replaces: libhwy1
 Breaks: libhwy1 (<< ${source:Version})
 Architecture: any
-Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Multi-Arch: same
 Description: Efficient and performance-portable SIMD wrapper (runtime files)
@@ -33,7 +34,6 @@
 Package: libhwy-dev
 Architecture: any
 Section: libdevel
-Pre-Depends: ${misc:Pre-Depends}
 Depends: libhwy1t64 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: Efficient and performance-portable SIMD wrapper (developer files)
